import 'package:comet_cli/config.dart';
import 'package:comet_cli/utils/crean_folder.dart';
import 'package:comet_cli/to_raw_data.dart';
import 'package:comet_cli/read_src_data.dart';
import 'package:comet_cli/read_yaml.dart';
import 'package:comet_cli/write_gen_data.dart';

Future<void> build() async {
  // Cometプロジェクトかどうか
  final cometYaml = readCometYaml();
  if (cometYaml == null) {
    print('Not found $cometYamlName');
    return;
  }

  // read src-data
  final srcData = await readSrcData(cometYaml);

  /// create raw-data
  final rawData = toRawData(srcData, cometYaml);

  // delete old gen-data
  cleanFolder('${cometYaml.flutterProject.root}/$genRoot');

  // write gen-dat
  await writeGenData(rawData);
}
