import 'dart:io';
import 'package:comet_cli/utils/can_use_command.dart';

Future<Process> runFlutter(
  String projectPath,
  List<String> args,
) async {
  final canUseFlutter = await canUseCommand('flutter');
  if (canUseFlutter) {
    final process = await Process.start(
      'flutter',
      args,
      runInShell: true,
      workingDirectory: projectPath,
    );
    return process;
  }

  final canUseFvm = await canUseCommand('fvm');
  if (canUseFvm) {
    final process = await Process.start(
      'fvm',
      [
        'flutter',
        ...args,
      ],
      runInShell: true,
      workingDirectory: projectPath,
    );
    return process;
  }

  throw Exception('Command Not Found: flutter');
}
