import 'dart:async';
import 'dart:io';

class ProgressStar {
  static const _items = [
    '[        ]',
    '[*       ]',
    '[-*      ]',
    '[--*     ]',
    '[---*    ]',
    '[ ---*   ]',
    '[  ---*  ]',
    '[   ---* ]',
    '[    ---*]',
    '[     ---]',
    '[      --]',
    '[       -]',
  ];

  static int _index = 0;
  static Timer? _timer;

  static void _incrementIndex() {
    _index = (_index + 1) % _items.length;
  }

  static void start() {
    stop();
    _timer = Timer.periodic(
      Duration(milliseconds: 100),
      (timer) {
        stdout.write('\r${_items[_index]} comet running..');
        _incrementIndex();
      },
    );
  }

  static void blink() {
    stop();
    _BlinkStar.start();
  }

  static void stop() {
    _timer?.cancel();
    _BlinkStar.stop();
  }
}

class _BlinkStar {
  static const _items = [
    '[ * * *  ]',
    '[        ]',
    '[  * * * ]',
    '[        ]',
  ];
  static int _index = 0;
  static Timer? _timer;

  static void _incrementIndex() {
    _index = (_index + 1) % _items.length;
  }

  static void start() {
    _timer?.cancel();
    _timer = Timer.periodic(
      Duration(milliseconds: 1000),
      (timer) {
        stdout.write('\r${_items[_index]} watching..');
        _incrementIndex();
      },
    );
  }

  static void stop() {
    _timer?.cancel();
  }
}
